Index: tests/run
===================================================================
--- tests/run	(revision 344)
+++ tests/run	(working copy)
@@ -3016,75 +3742,50 @@
 _ATEOF
 
 
-$at_traceoff
-echo "ref-mod.at:217: \${COMPILE} -o prog prog.cob"
-echo ref-mod.at:217 >$at_check_line_file
-( $at_traceon; ${COMPILE} -o prog prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "ref-mod.at:217: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/ref-mod.at:217: \${COMPILE} -o prog prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "ref-mod.at:217"
+( $at_check_trace; ${COMPILE} -o prog prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/ref-mod.at:217"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
+{ set +x
+$as_echo "$at_srcdir/ref-mod.at:218: ./prog"
+at_fn_check_prepare_trace "ref-mod.at:218"
+( $at_check_trace; ./prog
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:9: libcob: Length of 'X' out of bounds: 0
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/ref-mod.at:218"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-$at_traceon
 
-$at_traceoff
-echo "ref-mod.at:220: ./prog"
-echo ref-mod.at:220 >$at_check_line_file
-( $at_traceon; ./prog ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:9: libcob: Length of 'X' out of bounds: 0
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "ref-mod.at:220: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_24
+#AT_START_25
+at_fn_group_banner 25 'ref-mod.at:224' \
+  "Length overflow" "                                "
+at_xfail=no
+(
+  $as_echo "25. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
 
-
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
-
-  25 ) # 25. ref-mod.at:224: Length overflow
-    at_setup_line='ref-mod.at:224'
-    at_desc='Length overflow'
-    $at_quiet $ECHO_N " 25: Length overflow                              $ECHO_C"
-    at_xfail=no
-    (
-      echo "25. ref-mod.at:224: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -3100,75 +3801,50 @@
 _ATEOF
 
 
-$at_traceoff
-echo "ref-mod.at:240: \${COMPILE} -o prog prog.cob"
-echo ref-mod.at:240 >$at_check_line_file
-( $at_traceon; ${COMPILE} -o prog prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "ref-mod.at:240: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/ref-mod.at:240: \${COMPILE} -o prog prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "ref-mod.at:240"
+( $at_check_trace; ${COMPILE} -o prog prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/ref-mod.at:240"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
+{ set +x
+$as_echo "$at_srcdir/ref-mod.at:241: ./prog"
+at_fn_check_prepare_trace "ref-mod.at:241"
+( $at_check_trace; ./prog
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:9: libcob: Length of 'X' out of bounds: 5
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/ref-mod.at:241"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-$at_traceon
 
-$at_traceoff
-echo "ref-mod.at:243: ./prog"
-echo ref-mod.at:243 >$at_check_line_file
-( $at_traceon; ./prog ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:9: libcob: Length of 'X' out of bounds: 5
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "ref-mod.at:243: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_25
+#AT_START_26
+at_fn_group_banner 26 'accept.at:25' \
+  "ACCEPT FROM DATE/DAY" "                           "
+at_xfail=no
+(
+  $as_echo "26. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
 
-
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
-
-  26 ) # 26. accept.at:25: ACCEPT FROM DATE/DAY
-    at_setup_line='accept.at:25'
-    at_desc='ACCEPT FROM DATE/DAY'
-    $at_quiet $ECHO_N " 26: ACCEPT FROM DATE/DAY                         $ECHO_C"
-    at_xfail=no
-    (
-      echo "26. accept.at:25: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -3201,78 +3877,53 @@
 _ATEOF
 
 
-$at_traceoff
-echo "accept.at:58: \${COMPILE} -o prog prog.cob"
-echo accept.at:58 >$at_check_line_file
-( $at_traceon; ${COMPILE} -o prog prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "accept.at:58: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/accept.at:58: \${COMPILE} -o prog prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "accept.at:58"
+( $at_check_trace; ${COMPILE} -o prog prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/accept.at:58"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
-
-$at_traceon
-
-$at_traceoff
-echo "accept.at:64: ./prog"
-echo accept.at:64 >$at_check_line_file
-( $at_traceon; ./prog ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-echo >>$at_stdout; echo "(999999  )
+{ set +x
+$as_echo "$at_srcdir/accept.at:59: ./prog"
+at_fn_check_prepare_trace "accept.at:59"
+( $at_check_trace; ./prog
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+echo >>"$at_stdout"; $as_echo "(999999  )
 (99999999)
 (99999   )
 (9999999 )
-" | $at_diff - $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "accept.at:64: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+" | \
+  $at_diff - "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/accept.at:59"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_26
+#AT_START_27
+at_fn_group_banner 27 'initialize.at:29' \
+  "INITIALIZE group entry with OCCURS" "             "
+at_xfail=no
+(
+  $as_echo "27. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  27 ) # 27. initialize.at:29: INITIALIZE group entry with OCCURS
-    at_setup_line='initialize.at:29'
-    at_desc='INITIALIZE group entry with OCCURS'
-    $at_quiet $ECHO_N " 27: INITIALIZE group entry with OCCURS           $ECHO_C"
-    at_xfail=no
-    (
-      echo "27. initialize.at:29: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -3292,74 +3943,49 @@
 _ATEOF
 
 
-$at_traceoff
-echo "initialize.at:49: \${COMPILE} -o prog prog.cob"
-echo initialize.at:49 >$at_check_line_file
-( $at_traceon; ${COMPILE} -o prog prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:49: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/initialize.at:49: \${COMPILE} -o prog prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "initialize.at:49"
+( $at_check_trace; ${COMPILE} -o prog prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:49"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
+{ set +x
+$as_echo "$at_srcdir/initialize.at:50: ./prog"
+at_fn_check_prepare_trace "initialize.at:50"
+( $at_check_trace; ./prog
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+echo >>"$at_stdout"; $as_echo "   0" | \
+  $at_diff - "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:50"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-$at_traceon
 
-$at_traceoff
-echo "initialize.at:50: ./prog"
-echo initialize.at:50 >$at_check_line_file
-( $at_traceon; ./prog ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-echo >>$at_stdout; echo "   0" | $at_diff - $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:50: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_27
+#AT_START_28
+at_fn_group_banner 28 'initialize.at:55' \
+  "INITIALIZE OCCURS with numeric edited" "          "
+at_xfail=no
+(
+  $as_echo "28. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
 
-
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
-
-  28 ) # 28. initialize.at:55: INITIALIZE OCCURS with numeric edited
-    at_setup_line='initialize.at:55'
-    at_desc='INITIALIZE OCCURS with numeric edited'
-    $at_quiet $ECHO_N " 28: INITIALIZE OCCURS with numeric edited        $ECHO_C"
-    at_xfail=no
-    (
-      echo "28. initialize.at:55: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -3377,74 +4003,49 @@
 _ATEOF
 
 
-$at_traceoff
-echo "initialize.at:73: \${COMPILE} -o prog prog.cob"
-echo initialize.at:73 >$at_check_line_file
-( $at_traceon; ${COMPILE} -o prog prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:73: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/initialize.at:73: \${COMPILE} -o prog prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "initialize.at:73"
+( $at_check_trace; ${COMPILE} -o prog prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:73"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
+{ set +x
+$as_echo "$at_srcdir/initialize.at:74: ./prog"
+at_fn_check_prepare_trace "initialize.at:74"
+( $at_check_trace; ./prog
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+echo >>"$at_stdout"; $as_echo " 0 0 0 0 0" | \
+  $at_diff - "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:74"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-$at_traceon
 
-$at_traceoff
-echo "initialize.at:74: ./prog"
-echo initialize.at:74 >$at_check_line_file
-( $at_traceon; ./prog ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-echo >>$at_stdout; echo " 0 0 0 0 0" | $at_diff - $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:74: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_28
+#AT_START_29
+at_fn_group_banner 29 'initialize.at:79' \
+  "INITIALIZE complex group (1)" "                   "
+at_xfail=no
+(
+  $as_echo "29. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
 
-
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
-
-  29 ) # 29. initialize.at:79: INITIALIZE complex group (1)
-    at_setup_line='initialize.at:79'
-    at_desc='INITIALIZE complex group (1)'
-    $at_quiet $ECHO_N " 29: INITIALIZE complex group (1)                 $ECHO_C"
-    at_xfail=no
-    (
-      echo "29. initialize.at:79: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -3464,74 +4065,49 @@
 _ATEOF
 
 
-$at_traceoff
-echo "initialize.at:99: \${COMPILE} -o prog prog.cob"
-echo initialize.at:99 >$at_check_line_file
-( $at_traceon; ${COMPILE} -o prog prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:99: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/initialize.at:99: \${COMPILE} -o prog prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "initialize.at:99"
+( $at_check_trace; ${COMPILE} -o prog prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:99"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
+{ set +x
+$as_echo "$at_srcdir/initialize.at:100: ./prog"
+at_fn_check_prepare_trace "initialize.at:100"
+( $at_check_trace; ./prog
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+echo >>"$at_stdout"; $as_echo " 000" | \
+  $at_diff - "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:100"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-$at_traceon
 
-$at_traceoff
-echo "initialize.at:100: ./prog"
-echo initialize.at:100 >$at_check_line_file
-( $at_traceon; ./prog ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-echo >>$at_stdout; echo " 000" | $at_diff - $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:100: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_29
+#AT_START_30
+at_fn_group_banner 30 'initialize.at:104' \
+  "INITIALIZE complex group (2)" "                   "
+at_xfail=no
+(
+  $as_echo "30. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
 
-
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
-
-  30 ) # 30. initialize.at:104: INITIALIZE complex group (2)
-    at_setup_line='initialize.at:104'
-    at_desc='INITIALIZE complex group (2)'
-    $at_quiet $ECHO_N " 30: INITIALIZE complex group (2)                 $ECHO_C"
-    at_xfail=no
-    (
-      echo "30. initialize.at:104: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -3551,74 +4127,49 @@
 _ATEOF
 
 
-$at_traceoff
-echo "initialize.at:124: \${COMPILE} -o prog prog.cob"
-echo initialize.at:124 >$at_check_line_file
-( $at_traceon; ${COMPILE} -o prog prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:124: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/initialize.at:124: \${COMPILE} -o prog prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "initialize.at:124"
+( $at_check_trace; ${COMPILE} -o prog prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:124"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
+{ set +x
+$as_echo "$at_srcdir/initialize.at:125: ./prog"
+at_fn_check_prepare_trace "initialize.at:125"
+( $at_check_trace; ./prog
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+echo >>"$at_stdout"; $as_echo "0   0   " | \
+  $at_diff - "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:125"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-$at_traceon
 
-$at_traceoff
-echo "initialize.at:125: ./prog"
-echo initialize.at:125 >$at_check_line_file
-( $at_traceon; ./prog ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-echo >>$at_stdout; echo "0   0   " | $at_diff - $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:125: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_30
+#AT_START_31
+at_fn_group_banner 31 'initialize.at:129' \
+  "INITIALIZE with REDEFINES" "                      "
+at_xfail=no
+(
+  $as_echo "31. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
 
-
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
-
-  31 ) # 31. initialize.at:129: INITIALIZE with REDEFINES
-    at_setup_line='initialize.at:129'
-    at_desc='INITIALIZE with REDEFINES'
-    $at_quiet $ECHO_N " 31: INITIALIZE with REDEFINES                    $ECHO_C"
-    at_xfail=no
-    (
-      echo "31. initialize.at:129: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -3637,74 +4188,49 @@
 _ATEOF
 
 
-$at_traceoff
-echo "initialize.at:148: \${COMPILE} -o prog prog.cob"
-echo initialize.at:148 >$at_check_line_file
-( $at_traceon; ${COMPILE} -o prog prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:148: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/initialize.at:148: \${COMPILE} -o prog prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "initialize.at:148"
+( $at_check_trace; ${COMPILE} -o prog prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:148"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
+{ set +x
+$as_echo "$at_srcdir/initialize.at:149: ./prog"
+at_fn_check_prepare_trace "initialize.at:149"
+( $at_check_trace; ./prog
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+echo >>"$at_stdout"; $as_echo " 0" | \
+  $at_diff - "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:149"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-$at_traceon
 
-$at_traceoff
-echo "initialize.at:149: ./prog"
-echo initialize.at:149 >$at_check_line_file
-( $at_traceon; ./prog ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-echo >>$at_stdout; echo " 0" | $at_diff - $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:149: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_31
+#AT_START_32
+at_fn_group_banner 32 'initialize.at:153' \
+  "INITIALIZE with FILLER" "                         "
+at_xfail=no
+(
+  $as_echo "32. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
 
-
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
-
-  32 ) # 32. initialize.at:153: INITIALIZE with FILLER
-    at_setup_line='initialize.at:153'
-    at_desc='INITIALIZE with FILLER'
-    $at_quiet $ECHO_N " 32: INITIALIZE with FILLER                       $ECHO_C"
-    at_xfail=no
-    (
-      echo "32. initialize.at:153: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -3732,118 +4258,79 @@
 _ATEOF
 
 
-$at_traceoff
-echo "initialize.at:181: \${COMPILE} -o prog prog.cob"
-echo initialize.at:181 >$at_check_line_file
-( $at_traceon; ${COMPILE} -o prog prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:181: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/initialize.at:181: \${COMPILE} -o prog prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "initialize.at:181"
+( $at_check_trace; ${COMPILE} -o prog prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:181"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
+{ set +x
+$as_echo "$at_srcdir/initialize.at:182: ./prog"
+at_fn_check_prepare_trace "initialize.at:182"
+( $at_check_trace; ./prog
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/initialize.at:182"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-$at_traceon
 
-$at_traceoff
-echo "initialize.at:182: ./prog"
-echo initialize.at:182 >$at_check_line_file
-( $at_traceon; ./prog ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "initialize.at:182: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_32
+#AT_START_33
+at_fn_group_banner 33 'misc.at:23' \
+  "Source file not found" "                          "
+at_xfail=no
+(
+  $as_echo "33. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
 
+{ set +x
+$as_echo "$at_srcdir/misc.at:26: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "misc.at:26"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "cobc: prog.cob: No such file or directory
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/misc.at:26"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  33 ) # 33. misc.at:23: Source file not found
-    at_setup_line='misc.at:23'
-    at_desc='Source file not found'
-    $at_quiet $ECHO_N " 33: Source file not found                        $ECHO_C"
-    at_xfail=no
-    (
-      echo "33. misc.at:23: testing ..."
-      $at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_33
+#AT_START_34
+at_fn_group_banner 34 'misc.at:33' \
+  "Comma separator without space" "                  "
+at_xfail=no
+(
+  $as_echo "34. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
 
-$at_traceoff
-echo "misc.at:28: \${COMPILE_ONLY} prog.cob"
-echo misc.at:28 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "cobc: prog.cob: No such file or directory
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "misc.at:28: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
-
-  echo 1 > $at_status_file
-  exit 1
-fi
-
-$at_traceon
-
-
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
-
-  34 ) # 34. misc.at:33: Comma separator without space
-    at_setup_line='misc.at:33'
-    at_desc='Comma separator without space'
-    $at_quiet $ECHO_N " 34: Comma separator without space                $ECHO_C"
-    at_xfail=no
-    (
-      echo "34. misc.at:33: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
